
function [maximo,ampl_frec,minimo] = max_min(z,formantes)
%% z = respuesta en frecuencia
%% formantes = max numero de formantes que a priori se pueden encontrar,  
%%             el cual repercute a la array ampl_frec = [(1)x(max formantes)]
%%
%% maximo = array con los maximos
%% minimo = array con los minimos
%% ampl_frec = array con frecuencias y amplitudes de los maximos
%%             encontrados (los minimos no los muestra) 
%%
%% Ejemplo:     
%%          figure
%%          hold on
%%          plot(t,z,'o')
%%          plot(t,maximo,'r*')
%%          plot(t,minimo,'g*')
%%          hold off

ampl_frec=zeros(1,formantes);      %DEFINIREMOS ASI UNA ARRAY [(1)_x_(max formantes)] 
%%maximos
maximo(1)=z(1);
ampl_frec(1)=0;         %a frecuencia cero
ampl_frec(2)=z(1);      %amplitud
h=3;
for n=2:(length(z)-1)                              %si x(n-1) y x(n+1) son menores q x(n)
    if ( ((z(n))-(z(n-1)))>0 )&&( ((z(n))-(z(n+1)))>0 )                            %((abs(z(n))-abs(z(n-1)))&(abs(z(n))-abs(z(n+1))))>0

            maximo(n)=z(n);                                     %entonces z(n) es un maximo     
        if z(n)>0 %27-5-04 (si el maximo esta por encima de los 0dB)                 
            ampl_frec(h)=(n-1)*4000/(length(z)-1);   %frecuencia
            ampl_frec(h+1)=z(n); %amplitud
            h=h+2;
        end %27-5-04 
    else 
        maximo(n)=NaN;        %HAY Q PROBAR HABER SI SE PUEDE PONER--> maximo(n)=NaN;
    end
end
maximo(length(z))=z(length(z));             %512=length(z)
maximo=maximo';             %traspuesta
ampl_frec=ampl_frec';       %traspuesta

%%minimos
for n=2:(length(z)-1)                              %si x(n-1) y x(n+1) son menores q x(n)
    if ( ((z(n))-(z(n-1)))<0 )&&( ((z(n))-(z(n+1)))<0 )                            %((abs(z(n))-abs(z(n-1)))&(abs(z(n))-abs(z(n+1))))>0
        
            minimo(n)=z(n);                                     %entonces z(n) es un maximo
    else 
        minimo(n)=NaN;
    end
end
minimo(1)=NaN;
minimo(512)=NaN;
minimo=minimo';             %traspuesta
