function varargout = reconocedor_vocalico_page1(varargin)
% RECONOCEDOR_VOCALICO_PAGE1 M-file for reconocedor_vocalico_page1.fig
%      RECONOCEDOR_VOCALICO_PAGE1, by itself, creates a new RECONOCEDOR_VOCALICO_PAGE1 or raises the existing
%      singleton*.
%
%      H = RECONOCEDOR_VOCALICO_PAGE1 returns the handle to a new RECONOCEDOR_VOCALICO_PAGE1 or the handle to
%      the existing singleton*.
%
%      RECONOCEDOR_VOCALICO_PAGE1('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RECONOCEDOR_VOCALICO_PAGE1.M with the given input arguments.
%
%      RECONOCEDOR_VOCALICO_PAGE1('Property','Value',...) creates a new RECONOCEDOR_VOCALICO_PAGE1 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before reconocedor_vocalico_page1_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to reconocedor_vocalico_page1_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help reconocedor_vocalico_page1

% Last Modified by GUIDE v2.5 30-Jan-2005 13:16:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @reconocedor_vocalico_page1_OpeningFcn, ...
                   'gui_OutputFcn',  @reconocedor_vocalico_page1_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


function [ini,norm] = preproceso(data,Sc)

    x_mejorada=data-mean(data);   % elimino la componente continua


    apre=0.95;
    num=[1 -apre];                % amplifica las altas frecuencias(4000=Fs1/2) (filtro pasa-alta)
    den=1;
    [Hpre,wn]=freqz(num,den);     % respuesta en frecuencia del filtro preenfasis
    salida=filter(num,den,x_mejorada);           % filtro de pre-enfasis 
    

    norm=salida/max(abs(salida)); % seal se encuentra entre [+1,-1] de amplitud
    
    
    ini=0;               %inicializo inicio
    cont=0;
    N=256;     %256                  %Longitud de la ventana de analisis
    s=norm;
    T=abs(s).^2;
    E(1)=T(1);                  %calculo de la energia localizada
    for i=2:(N-1)
        E(i)=E(i-1)+T(i);
    end
    for m=N:length(T)
        E(m)=0;
        for i=(m-N+1):(m)
            E(m)=T(i)+E(m);
        end
    end
    P=E*1/N;        %potencia
    for i=1:length(s)
        if s(i)>=0
            T(i)=1;
        elseif s(i)<0
            T(i)=-1;
        end
    end
    T=1/2*abs( T(2:length(T)) - T(1:length(T)-1) );
    ZCR(1)=0;                    %calculo de la tasa de cruces por cero
    for i=2:(N-1)
        ZCR(i)=ZCR(i-1)+T(i);
    end
    for m=N:length(T)
        ZCR(m)=0;
        for i=(m-N+1):(m)
            ZCR(m)=T(i)+ZCR(m);
        end
    end
    ZCR=ZCR*1/N;
    ZCR(length(s))=0;
    %Sc=2000;    %valor tipico 2000
    W=P.*(1-ZCR).*Sc;
    nu_w=mean(W);               %media
    delta_w=std(W);             %varianza
    alfa=0.2*delta_w^(-0.8);
    tw=nu_w+alfa*delta_w;
    for i=1:length(W)
        if W(i)>=tw
        
            VAD(i)=1;
            cont=cont+1;
            if cont==500
                ini=i-500;     %cuando existe mucha actividad seguida es q estamos en la vocal
            end                 %guardamos el inicio de la vocal
        
        elseif W(i)<tw
            VAD(i)=0;
            cont=0;         %cuando no entuentra actividad resetemos el contador
        end
    end


    
function [formantes]=extraccion(ini,data,Fs,n_tramas,n_coef,sonido,generador,ver_plot)

    %ini=ini-160; %zona de seguridad
    ini;

    lontrama=0.04*Fs;                      %longitud de la trama 40 ms, en muestras se cal ( n_longtramas = 40ms x Frec muestreo )
    %n_tramas=3; %actualizado (5-11-04) n_tramas=3 consiguiendo asi 4 tramas solapadas
    solapa=0.5;                             %solapamiento del 50%
    x1=data(ini:ini+( (n_tramas+1)*solapa*lontrama));
    septramas=(1-solapa)*lontrama;          %separacion entre tramas (cuando el solape es del 50%) es 20ms
    ventana=hamming(lontrama);

    metalico=0;     %inicializo
    cont=0;         %inicializo contador
    for j=1:septramas:(n_tramas-1)*lontrama                 %desde 1 hasta long de x1, pero de 20ms en 20ms
        
        %Extraccion coef LPC
        cont=cont+1;
        resultante=hamming(lontrama).*x1(j:j+lontrama-1);   %aplico la ventana hamming de 40ms a una porcion de la seal x1 tb de 40ms 
        %n_coef=12;                          %probamos sacando 5 coeficientes LPC, pero tengo 5+1 y el 1 coef vale siempe 1 
        coef(cont,:)=real(lpc(resultante,n_coef));                  %extraigo los coefientes LPC
    
        if (sonido==0)
            %el usuario no desea escuchar la modelizacion de la vocal
        elseif (generador==0)    
            %La excitacion por un tren de impulsos periodico funciona mejor
            excitacion=randn(1,septramas); %Ruido blanco
                                                %                           const                          B
            B=1;    %numerador                  %   LPC =    -------------------------------------  ->  --------
            A=coef(cont,:); %denominador        %              1 + A(0) + A(1) + ... + A(n_coef)          coef    
            res=filter(B,A,excitacion);
            metalico=[metalico res];
            
        else
            %Generacion de un tren de impulsos periodico como excitacion
            frectren=100;                       %Frecuencia del tren de impulsos en Hz
            pulso=round(Fs/frectren);
            excitacion=zeros(1,septramas);
            excitacion(1:pulso:end)=1;          %Tren de impulsos periodicos con frec 100Hz
            
                                                %                           const                          B
            B=1;    %numerador                  %   LPC =    -------------------------------------  ->  --------
            A=coef(cont,:); %denominador        %              1 + A(0) + A(1) + ... + A(n_coef)          coef    
            res=filter(B,A,excitacion);
            metalico=[metalico res];
            
        end
        
        
        %resp. en frecuencia del filtro bucal
        [a,w]=freqz(1,coef(cont,:));
        maxfilas=14;    %como maximo encontrare 6 'maximos' en una resp en frec de una vocal, + el 
                        %valor en frec=0 , + el valor de la frec de cada 'maximo' , hace un
                        %total de 14 valores , 14 filas tendre como maximo.                
        z=20*log10(abs(a));
        t=0:0.5*Fs/(length(z)-1):0.5*Fs;
        z=z';   %traspuesta 1x512
        
        [maxi,ampl_frec,mini]=max_min(z,maxfilas);       %%llama a la funcion 
        resonancias(:,cont)=ampl_frec;
        plot_t(cont,:)=t;
        plot_z(cont,:)=z;
        if (cont==n_tramas)
            break;
        end
    end
    sound(metalico,Fs)
    
    
    if (ver_plot==0)
        %el usuario no desea ver la resp. en frec. del filtro bucal de cada
        %segmento
    else
        
        bucal(plot_t',plot_z');
        
    end
    
    
    x=3;        %guardo el 1 y 2 formante
    y=5;
    n=1:n_tramas;  %%%solo tengo tres segmentos
    formantes=[resonancias(x,n)+i*resonancias(y,n)];       % 1 formante eje real , 2 formante eje imaginario
    %formantes=[prua1(x,1)+i*prua1(y,1),prua1(x,2)+i*prua1(y,2),prua1(x,3)+i*prua1(y,3)];
    
    
    


function clustering(datos,centros,handles)
    %centros =  [ /a//a/ /e//e/ /i//i/ /o//o/ /u//u/ ]     
    N=length(datos);
    cont=zeros(1,length(centros)); %este vector lleva el numero de veces que un centro gana
    for t=1:N
  
        distancias=abs(centros-datos(t)); %%al usar complejos puedo calcular la distancia de un
        %%%patron a los centros de una tacada %%%%%%%%
        [a,ind]=min(distancias); %%%ind indica el centro que gana 
        cont(ind)=cont(ind)+1;
        
    end
    
    % Crear plot clustering
    axes(handles.clustering_axes)
    centros_plot=[centros(1),centros(2);centros(3),centros(4);centros(5),centros(6);centros(7),centros(8);centros(9),centros(10)];
    n=1;
    plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','b')
    hold on
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','g')   
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','r')
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','c')
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','m')
    plot(real(datos(:)),imag(datos(:)),'k*')
    xlabel('Frecuencia 1 formante (Hz)');
    ylabel('Frecuencia 2 formante (Hz)');
    legend('/a/','/e/','/i/','/o/','/u/')
    
    [a,ind]=max(cont);%%%ind indica el centro mayoritario
    
    if ( ind==1 || ind==2 )
        
        plot(real(centros(1)),imag(centros(1)),'ko',real(centros(2)),imag(centros(2)),'ko','MarkerFaceColor',[1,1,1])   %[1,1,1]=color blanco
        title('vocal reconocida /a/','Color','r','FontName','Vineta BT','Fontsize',11)   %r=red=[1,0,0]
        hold off
        
    elseif ( ind==3 || ind==4 )
        
        plot(real(centros(3)),imag(centros(3)),'ko',real(centros(4)),imag(centros(4)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /e/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( ind==5 || ind==6 )

        plot(real(centros(5)),imag(centros(5)),'ko',real(centros(6)),imag(centros(6)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /i/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( ind==7 || ind==8 )
        
        plot(real(centros(7)),imag(centros(7)),'ko',real(centros(8)),imag(centros(8)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /o/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( ind==9 || ind==10 )
        
        plot(real(centros(9)),imag(centros(9)),'ko',real(centros(10)),imag(centros(10)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /u/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    end
    
    
if 0    
    if ( (cont(1)+cont(2)==2) || (cont(1)+cont(2)==3) )
        
        plot(real(centros(1)),imag(centros(1)),'ko',real(centros(2)),imag(centros(2)),'ko','MarkerFaceColor',[1,1,1])   %[1,1,1]=color blanco
        title('vocal reconocida /a/','Color','r','FontName','Vineta BT','Fontsize',11)   %r=red=[1,0,0]
        hold off
        
    elseif ( (cont(3)+cont(4)==2) || (cont(3)+cont(4)==3) )
        
        plot(real(centros(3)),imag(centros(3)),'ko',real(centros(4)),imag(centros(4)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /e/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( (cont(5)+cont(6)==2) || (cont(5)+cont(6)==3) )

        plot(real(centros(5)),imag(centros(5)),'ko',real(centros(6)),imag(centros(6)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /i/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( (cont(7)+cont(8)==2) || (cont(7)+cont(8)==3) )
        
        plot(real(centros(7)),imag(centros(7)),'ko',real(centros(8)),imag(centros(8)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /o/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( (cont(9)+cont(10)==2) || (cont(9)+cont(10)==3) )
        
        plot(real(centros(9)),imag(centros(9)),'ko',real(centros(10)),imag(centros(10)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /u/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    else
        
        title('repita de nuevo la vocal','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    end
end

    
function mostrar_datos_centros(datos, centros, handles)    
    
    % Crear plot clustering
    axes(handles.clustering_axes)
    n=1/5*length(datos);
    plot(real(datos(1:n)),imag(datos(1:n)),'b.',real(datos(1+n:2*n)),imag(datos(1+n:2*n)),'g.',real(datos(1+n*2:3*n)),imag(datos(1+n*2:3*n)),'r.',...
         real(datos(1+n*3:4*n)),imag(datos(1+n*3:4*n)),'c.',real(datos(1+n*4:5*n)),imag(datos(1+n*4:5*n)),'m.')   
    xlabel('Frecuencia 1 formante (Hz)');
    ylabel('Frecuencia 2 formante (Hz)');
    title('Datos de 8 usuarios / Centros resultantes','FontName','Vineta BT','Fontsize',9,'Position', [710 3700 0]);%
    hold on
    plot(centros,'ko','MarkerFaceColor',[1,1,1]);
    hold off
    legend('datos /a/','/e/','/i/','/o/','/u/','centros')



% --- Executes just before reconocedor_vocalico_page1 is made visible.
function reconocedor_vocalico_page1_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to reconocedor_vocalico_page1 (see VARARGIN)

%crear estructuras
load('default_page1.mat');
handles.ruido_default=ruido_default;                        handles.ruido=ruido_default;            %(por defecto)
handles.VAD_Sc_default=VAD_Sc_default;                      handles.VAD_Sc=VAD_Sc_default;          %(por defecto)
handles.sonido_default=sonido_default;                      handles.sonido=sonido_default;          %(por defecto)
handles.segmentado_default=segmentado_default;              handles.segmentado=segmentado_default;  %(por defecto)
handles.coef_LPC_default=coef_LPC_default;                  handles.coef_LPC=coef_LPC_default;      %(por defecto)
handles.sintetizado_sonido_default=sintetizado_sonido_default;        handles.sintetizado_sonido=sintetizado_sonido_default;%(por defecto)
handles.sintetizado_generador_default=sintetizado_generador_default;  handles.sintetizado_generador=sintetizado_generador_default;%(por defecto)
handles.filtro_bucal_default=filtro_bucal_default;          handles.filtro_bucal=filtro_bucal_default;            %(por defecto)

load('centroides_FCM.mat');
handles.Z_FCM=centros;
load('centroides_LVQ.mat');
handles.Z_LVQ=centros;
load('centroides_HCM.mat');
handles.Z_HCM=centros;

load('datos80porcien.mat');
handles.datos_usuarios=datos80porcien;

%ejemplos vocalicos
[handles.voz1,handles.Fs1,handles.bits1]=wavread('a.wav');
[handles.voz2,handles.Fs2,handles.bits2]=wavread('e.wav');
[handles.voz3,handles.Fs3,handles.bits3]=wavread('i.wav');
[handles.voz4,handles.Fs4,handles.bits4]=wavread('o.wav');
[handles.voz5,handles.Fs5,handles.bits5]=wavread('u.wav');

%inicializo con FCM por ser el mejor metodo
handles.current_Z=handles.Z_FCM;

% Choose default command line output for reconocedor_vocalico_page1
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes reconocedor_vocalico_page1 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = reconocedor_vocalico_page1_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in ejemplo1_pushbutton.
function ejemplo1_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ejemplo1_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

voz=handles.voz1;
nivel_ruido=handles.ruido;

    if (nivel_ruido==0)
        %el usuario no desea la seal con ruido
    else
        load('ruido blanco.mat');
        ruido=ruido_blanco(1:length(voz)); %Ruido blanco
        ruido_blanco1=ruido/max(abs(ruido));
        for i=1:length(voz)
            if (abs(nivel_ruido*ruido_blanco1(i))>abs(voz(i)))
                voz(i)=nivel_ruido*ruido_blanco1(i);
            else
                voz(i)=voz(i);
            end
        end
    end
    
    if (handles.sonido==0)
        %el usuario no desea escuchar la vocal
    else
        sound(voz,handles.Fs1);
    end
    
% Display Ejemplo1 plot of the currently selected data(reconocedor_online)
[ini,norm]=preproceso(voz,handles.VAD_Sc);
[formantes]=extraccion( ini, norm, handles.Fs1,handles.segmentado,handles.coef_LPC,...
                        handles.sintetizado_sonido,handles.sintetizado_generador,...
                        handles.filtro_bucal );
clustering(formantes, handles.current_Z, handles);

%Desabilitar la opcion de ver la resp. en frec. del filtro bucal
%handles.filtro_bucal=0;
%guidata(hObject, handles);    %guardar cambios


% --- Executes on button press in ejemplo2_pushbutton.
function ejemplo2_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ejemplo2_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

voz=handles.voz2;
nivel_ruido=handles.ruido;

    if (nivel_ruido==0)
        %el usuario no desea la seal con ruido
    else
        load('ruido blanco.mat');
        ruido=ruido_blanco(1:length(voz)); %Ruido blanco
        ruido_blanco1=ruido/max(abs(ruido));
        for i=1:length(voz)
            if (abs(nivel_ruido*ruido_blanco1(i))>abs(voz(i)))
                voz(i)=nivel_ruido*ruido_blanco1(i);
            else
                voz(i)=voz(i);
            end
        end
    end
    
    if (handles.sonido==0)
        %el usuario no desea escuchar la vocal
    else
        sound(voz,handles.Fs2);
    end
    
% Display Ejemplo1 plot of the currently selected data(reconocedor_online)
[ini,norm]=preproceso(voz,handles.VAD_Sc);
[formantes]=extraccion( ini, norm, handles.Fs2,handles.segmentado,handles.coef_LPC,...
                        handles.sintetizado_sonido,handles.sintetizado_generador,...
                        handles.filtro_bucal );
clustering(formantes, handles.current_Z, handles);

% --- Executes on button press in ejemplo3_pushbutton.
function ejemplo3_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ejemplo3_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

voz=handles.voz3;
nivel_ruido=handles.ruido;

    if (nivel_ruido==0)
        %el usuario no desea la seal con ruido
    else
        load('ruido blanco.mat');
        ruido=ruido_blanco(1:length(voz)); %Ruido blanco
        ruido_blanco1=ruido/max(abs(ruido));
        for i=1:length(voz)
            if (abs(nivel_ruido*ruido_blanco1(i))>abs(voz(i)))
                voz(i)=nivel_ruido*ruido_blanco1(i);
            else
                voz(i)=voz(i);
            end
        end
    end
    
    if (handles.sonido==0)
        %el usuario no desea escuchar la vocal
    else
        sound(voz,handles.Fs3);
    end
    
% Display Ejemplo1 plot of the currently selected data(reconocedor_online)
[ini,norm]=preproceso(voz,handles.VAD_Sc);
[formantes]=extraccion( ini, norm, handles.Fs3,handles.segmentado,handles.coef_LPC,...
                        handles.sintetizado_sonido,handles.sintetizado_generador,...
                        handles.filtro_bucal );
clustering(formantes, handles.current_Z, handles);

% --- Executes on button press in ejemplo4_pushbutton.
function ejemplo4_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ejemplo4_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

voz=handles.voz4;
nivel_ruido=handles.ruido;

    if (nivel_ruido==0)
        %el usuario no desea la seal con ruido
    else
        load('ruido blanco.mat');
        ruido=ruido_blanco(1:length(voz)); %Ruido blanco
        ruido_blanco1=ruido/max(abs(ruido));
        for i=1:length(voz)
            if (abs(nivel_ruido*ruido_blanco1(i))>abs(voz(i)))
                voz(i)=nivel_ruido*ruido_blanco1(i);
            else
                voz(i)=voz(i);
            end
        end
    end
    
    if (handles.sonido==0)
        %el usuario no desea escuchar la vocal
    else
        sound(voz,handles.Fs4);
    end
    
% Display Ejemplo1 plot of the currently selected data(reconocedor_online)
[ini,norm]=preproceso(voz,handles.VAD_Sc);
[formantes]=extraccion( ini, norm, handles.Fs4,handles.segmentado,handles.coef_LPC,...
                        handles.sintetizado_sonido,handles.sintetizado_generador,...
                        handles.filtro_bucal );
clustering(formantes, handles.current_Z, handles);

% --- Executes on button press in ejemplo5_pushbutton.
function ejemplo5_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ejemplo5_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

voz=handles.voz5;
nivel_ruido=handles.ruido;

    if (nivel_ruido==0)
        %el usuario no desea la seal con ruido
    else
        load('ruido blanco.mat');
        ruido=ruido_blanco(1:length(voz)); %Ruido blanco
        ruido_blanco1=ruido/max(abs(ruido));
        for i=1:length(voz)
            if (abs(nivel_ruido*ruido_blanco1(i))>abs(voz(i)))
                voz(i)=nivel_ruido*ruido_blanco1(i);
            else
                voz(i)=voz(i);
            end
        end
    end
    
    if (handles.sonido==0)
        %el usuario no desea escuchar la vocal
    else
        sound(voz,handles.Fs5);
    end
    
% Display Ejemplo1 plot of the currently selected data(reconocedor_online)
[ini,norm]=preproceso(voz,handles.VAD_Sc);
[formantes]=extraccion( ini, norm, handles.Fs5,handles.segmentado,handles.coef_LPC,...
                        handles.sintetizado_sonido,handles.sintetizado_generador,...
                        handles.filtro_bucal );
clustering(formantes, handles.current_Z, handles);

% --- Executes on button press in datos_centro_pushbutton.
function datos_centro_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to datos_centro_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% muestra los resutados experimentales
% muestra todos los datos de las voces y pulsando un algoritmo se observan
% los centroides resultantes.

mostrar_datos_centros(handles.datos_usuarios, handles.current_Z, handles)


% --- Executes on button press in online_pushbutton.
function online_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to online_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ir a la pagina 2 (reconocedor online)
%open('reconocedor_vocalico_page2.fig')
%close('reconocedor_vocalico_page1')
reconocedor_vocalico_page2

% --- Executes during object creation, after setting all properties.
function plot_barramenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_barramenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in plot_barramenu.
function plot_barramenu_Callback(hObject, eventdata, handles)
% hObject    handle to plot_barramenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns plot_barramenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plot_barramenu

val = get(hObject,'Value');
str = get(hObject, 'String');
switch str{val};
case 'FCM' % User selects cebtroides FCM
    handles.current_Z = handles.Z_FCM;
case 'LVQ' % User selects centroides LVQ
    handles.current_Z = handles.Z_LVQ;
case 'HCM' % User selects centroides HCM
    handles.current_Z = handles.Z_HCM;
end
guidata(hObject,handles)    %guardar cambios


% --------------------------------------------------------------------
function menu_opciones_Callback(hObject, eventdata, handles)
% hObject    handle to menu_opciones (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_ruido_Callback(hObject, eventdata, handles)
% hObject    handle to menu_ruido (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_sin_ruido_Callback(hObject, eventdata, handles)
% hObject    handle to menu_sin_ruido (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.ruido=handles.ruido_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_con_ruido_Callback(hObject, eventdata, handles)
% hObject    handle to menu_con_ruido (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.ruido), num2str(handles.segmentado), num2str(handles.coef_LPC), num2str(handles.VAD_Sc) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.ruido = str2num( datos_act{1} );
handles.segmentado = str2num( datos_act{2} );
handles.coef_LPC = str2num( datos_act{3} );
handles.VAD_Sc = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_sonido_Callback(hObject, eventdata, handles)
% hObject    handle to menu_sonido (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_escuchar_Callback(hObject, eventdata, handles)
% hObject    handle to menu_escuchar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sonido=handles.sonido_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_no_escuchar_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_escuchar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sonido=0;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_adquisicion_procesado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_adquisicion_procesado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_vad_Callback(hObject, eventdata, handles)
% hObject    handle to menu_vad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_segmentado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_segmentado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_LPC_Callback(hObject, eventdata, handles)
% hObject    handle to menu_LPC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_modelizado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_modelizado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_filtro_bucal_Callback(hObject, eventdata, handles)
% hObject    handle to menu_filtro_bucal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_clustering_Callback(hObject, eventdata, handles)
% hObject    handle to menu_clustering (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_no_vad_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_vad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.VAD_Sc=handles.VAD_Sc_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_si_vad_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_vad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.ruido), num2str(handles.segmentado), num2str(handles.coef_LPC), num2str(handles.VAD_Sc) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.ruido = str2num( datos_act{1} );
handles.segmentado = str2num( datos_act{2} );
handles.coef_LPC = str2num( datos_act{3} );
handles.VAD_Sc = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_no_segmentado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_segmentado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.segmentado=handles.segmentado_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_si_segmentado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_segmentado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.ruido), num2str(handles.segmentado), num2str(handles.coef_LPC), num2str(handles.VAD_Sc) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.ruido = str2num( datos_act{1} );
handles.segmentado = str2num( datos_act{2} );
handles.coef_LPC = str2num( datos_act{3} );
handles.VAD_Sc = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_no_coef_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_coef (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.coef_LPC=handles.coef_LPC_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_si_coef_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_coef (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.ruido), num2str(handles.segmentado), num2str(handles.coef_LPC), num2str(handles.VAD_Sc) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.ruido = str2num( datos_act{1} );
handles.segmentado = str2num( datos_act{2} );
handles.coef_LPC = str2num( datos_act{3} );
handles.VAD_Sc = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_modelizado_escuchar_Callback(hObject, eventdata, handles)
% hObject    handle to menu_modelizado_escuchar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_si_modelizado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_modelizado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sintetizado_sonido=1;
handles.sonido=1;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_resp_frec_Callback(hObject, eventdata, handles)
% hObject    handle to menu_resp_frec (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.filtro_bucal=1;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_variables_Callback(hObject, eventdata, handles)
% hObject    handle to menu_variables (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    s = {'FCM____________________________________' , '',...
         '          Umbral = 1e-8',...
         '          Grado de borrosificacion = 1.5','',...
	     'HCM____________________________________' ,'', ...
         '          Umbral = 0.5','',...
   	     'LVQ____________________________________' ,'', ...
         '          Constante de aprendizaje = 0.03'};
    errordlg(s,'Variables Clustering no modificables');

% --------------------------------------------------------------------
function menu_variables_defecto_Callback(hObject, eventdata, handles)
% hObject    handle to menu_variables_defecto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.ruido = handles.ruido_default;
handles.segmentado = handles.segmentado_default;
handles.coef_LPC = handles.coef_LPC_default;
handles.VAD_Sc = handles.VAD_Sc_default;
guidata(hObject, handles);    %guardar cambios


% --------------------------------------------------------------------
function menu_no_modelizado_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_modelizado (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sintetizado_sonido=handles.sintetizado_sonido_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_fuente_Callback(hObject, eventdata, handles)
% hObject    handle to menu_fuente (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_tren_implusos_Callback(hObject, eventdata, handles)
% hObject    handle to menu_tren_implusos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sintetizado_generador=1;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_ruido_blanco_Callback(hObject, eventdata, handles)
% hObject    handle to menu_ruido_blanco (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sintetizado_generador=0;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_ayuda_Callback(hObject, eventdata, handles)
% hObject    handle to menu_ayuda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_manual_Callback(hObject, eventdata, handles)
% hObject    handle to menu_manual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hBar = waitbar(0.25,'Opening internet browser...');
pause(0.5)
waitbar(1);
pause(0.3)
letras=length(mfilename);
lugar = which(mfilename);
URL = [ lugar(1:end-letras-2) , 'ayuda\','Manual.htm'];
STAT = web(URL,'-browser');
close(hBar);    
switch STAT
case {1,2}
    s = {'Su navegador no se ha activado o no ha' , ...
	     'encontrado el archivo.  Por favor use su' , ...
	     'navegador para abrir el archivo:' , ...
	     ' ', '     Manual.htm', ' ', ...
	     'se encuentra en el directorio ayuda de RVIL-ACv1.0'};
    errordlg(s,'Error al lanzar el navegador.');
end


% --------------------------------------------------------------------
function menu_salir_Callback(hObject, eventdata, handles)
% hObject    handle to menu_salir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close('reconocedor_vocalico_page1');





