function varargout = reconocedor_vocalico_page2(varargin)
% RECONOCEDOR_VOCALICO_PAGE2 M-file for reconocedor_vocalico_page2.fig
%      RECONOCEDOR_VOCALICO_PAGE2, by itself, creates a new RECONOCEDOR_VOCALICO_PAGE2 or raises the existing
%      singleton*.
%
%      H = RECONOCEDOR_VOCALICO_PAGE2 returns the handle to a new RECONOCEDOR_VOCALICO_PAGE2 or the handle to
%      the existing singleton*.
%
%      RECONOCEDOR_VOCALICO_PAGE2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RECONOCEDOR_VOCALICO_PAGE2.M with the given input arguments.
%
%      RECONOCEDOR_VOCALICO_PAGE2('Property','Value',...) creates a new RECONOCEDOR_VOCALICO_PAGE2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before reconocedor_vocalico_page2_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to reconocedor_vocalico_page2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help reconocedor_vocalico_page2

% Last Modified by GUIDE v2.5 31-Jan-2005 20:38:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @reconocedor_vocalico_page2_OpeningFcn, ...
                   'gui_OutputFcn',  @reconocedor_vocalico_page2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT



function  handles = adquirir(hObject, eventdata, handles)
% crear analog input (adquirir datos)
ai = analoginput('winsound');   %adquirir seal analogica de la tarjeta de sonido
addchannel(ai,1:2);             % aadir dos canales (obligado)

% configuracion
set(ai, 'SampleRate', 8000);
set(ai, 'SamplesPerTrigger', 10000);    % coger 10000 muestras cal, otras 10000 calcula...                                

% iniciar la adquisicion
%axes(handles.wave_axes)
%plot([0 0 0]);
%text(1.12,0.5,'Adquiriendo','Color','b')
text(0.1,0.5,'Adquiriendo','Color','b')

start(ai)
data = getdata(ai);

% Crear plot datos de entrada por microfono (wave)
axes(handles.wave_axes)
plot(data(:,1));
xlabel('Sample');
ylabel('Analog Input (Volts)');
title('Analog Data Acquisition');

% crear estructuras
handles.voz = data(:,1);
handles.Fs = get(ai, 'SampleRate');
handles.blockSize = get(ai, 'SamplesPerTrigger');

guidata(hObject,handles)    %guardar cambios


function [ini,norm] = preproceso(data)

    x_mejorada=data-mean(data);   % elimino la componente continua


    apre=0.95;
    num=[1 -apre];                % amplifica las altas frecuencias(4000=Fs1/2) (filtro pasa-alta)
    den=1;
    [Hpre,wn]=freqz(num,den);     % respuesta en frecuencia del filtro preenfasis
    salida=filter(num,den,x_mejorada);           % filtro de pre-enfasis 


    norm=salida/max(abs(salida)); % seal se encuentra entre [+1,-1] de amplitud


    ini=0;               %inicializo inicio
    cont=0;
    N=256;     %256                  %Longitud de la ventana de analisis
    s=norm;
    T=abs(s).^2;
    E(1)=T(1);                  %calculo de la energia localizada
    for i=2:(N-1)
        E(i)=E(i-1)+T(i);
    end
    for m=N:length(T)
        E(m)=0;
        for i=(m-N+1):(m)
            E(m)=T(i)+E(m);
        end
    end
    P=E*1/N;        %potencia
    for i=1:length(s)
        if s(i)>=0
            T(i)=1;
        elseif s(i)<0
            T(i)=-1;
        end
    end
    T=1/2*abs( T(2:length(T)) - T(1:length(T)-1) );
    ZCR(1)=0;                    %calculo de la tasa de cruces por cero
    for i=2:(N-1)
        ZCR(i)=ZCR(i-1)+T(i);
    end
    for m=N:length(T)
        ZCR(m)=0;
        for i=(m-N+1):(m)
            ZCR(m)=T(i)+ZCR(m);
        end
    end
    ZCR=ZCR*1/N;
    ZCR(length(s))=0;
    Sc=2000;    %valor tipico 2000
    W=P.*(1-ZCR).*Sc;
    nu_w=mean(W);               %media
    delta_w=std(W);             %varianza
    alfa=0.2*delta_w^(-0.8);
    tw=nu_w+alfa*delta_w;
    for i=1:length(W)
        if W(i)>=tw
        
            VAD(i)=1;
            cont=cont+1;
            if cont==500
                ini=i-500;     %cuando existe mucha actividad seguida es q estamos en la vocal
            end                 %guardamos el inicio de la vocal
        
        elseif W(i)<tw
            VAD(i)=0;
            cont=0;         %cuando no entuentra actividad resetemos el contador
        end
    end


    
function [formantes] = extraccion(ini,data,Fs)

    %ini=ini-160; %zona de seguridad
    ini;

    lontrama=0.04*Fs;                      %longitud de la trama 40 ms, en muestras se cal ( n_longtramas = 40ms x Frec muestreo )
    %n_tramas=floor(length(x1)/lontrama);    %numero de tramas que necesito (floor 'o' fix -> redondean a la baja. ej floor(5.8)=5)
    n_tramas=3; %original 5 , actualizado (5-11-04) n_tramas=3 consiguiendo asi 4 tramas solapadas
    x1=data(ini:ini+(n_tramas*lontrama));
    solapa=0.5;                             %solapamiento del 50%
    septramas=(1-solapa)*lontrama;          %separacion entre tramas (cuando el solape es del 50%) es 20ms
    ventana=hamming(lontrama);


    cont=0;         %inicializo contador
    for j=1:septramas:(n_tramas-1)*lontrama                 %desde 1 hasta long de x1, pero de 20ms en 20ms
    
        cont=cont+1;
        resultante=hamming(lontrama).*x1(j:j+lontrama-1);   %aplico la ventana hamming de 40ms a una porcion de la seal x1 tb de 40ms 
        n_coef=12;                          %probamos sacando 5 coeficientes LPC, pero tengo 5+1 y el 1 coef vale siempe 1 
        coef(cont,:)=real(lpc(resultante,n_coef));                  %extraigo los coefientes LPC
    
    end


    [a01,w1]=freqz(1,coef(1,:));
    [a02,w2]=freqz(1,coef(2,:));
    [a03,w3]=freqz(1,coef(3,:));


    maxfilas=14;    %como maximo encontrare 6 'maximos' en una resp en frec de una vocal, + el 
                    %valor en frec=0 , + el valor de la frec de cada 'maximo' , hace un
                    %total de 14 valores , 14 filas tendre como maximo.
    z=20*log10(abs(a01));
    z=z';   %traspuesta 1x512
    [maxi,ampl_frec,mini]=max_min(z,maxfilas);       %%llama a la funcion 
    prua1(:,1)=ampl_frec;

    z=20*log10(abs(a02));
    z=z';   %traspuesta 1x512
    [maxi,ampl_frec,mini]=max_min(z,maxfilas);       %%llama a la funcion 
    prua1(:,2)=ampl_frec;

    z=20*log10(abs(a03));
    z=z';   %traspuesta 1x512
    [maxi,ampl_frec,mini]=max_min(z,maxfilas);       %%llama a la funcion 
    prua1(:,3)=ampl_frec;


    x=3;        %guardo el 1 y 2 formante
    y=5;
    n=1:3;  %%%solo tengo tres segmentos
    %formantes=[prua1(x,n)+i*prua1(y,n)];       % 1 formante eje real , 2 formante eje imaginario
    formantes=[prua1(x,1)+i*prua1(y,1),prua1(x,2)+i*prua1(y,2),prua1(x,3)+i*prua1(y,3)];
    
    

function clustering(datos,centros,handles)
    %centros =  [ /a//a/ /e//e/ /i//i/ /o//o/ /u//u/ ]    
    mostrar=1;
    if (handles.clasificacion==0 || handles.recalcular==0)
        if handles.recalcular==0 && handles.clasificacion==1
                % Crear en plot clustering no se ha adquirido la voz
                axes(handles.clustering_axes)
                plot([0 0 0]);    
                xlabel('Frecuencia 1 formante (Hz)');
                ylabel('Frecuencia 2 formante (Hz)');
                text(1.12,0.5,'Los centros no han sido recalculados','Color','b')
                text(1.25,0.25,'Presione de nuevo -> Recalcular','Color','b')
                mostrar=0;
        else
            %centros son los almacenados en memoria
        end
    else 
        if centros == handles.Z_FCM
            centroides=handles.centros_recalc_FCM;
            centros=centroides(:,1)+i*centroides(:,2);
        elseif centros == handles.Z_LVQ
            centros=handles.centros_recalc_LVQ;
        elseif centros == handles.Z_HCM
            centros=handles.centros_recalc_HCM;  
        end
    end
 
 if mostrar==1
    N=length(datos);
    cont=zeros(1,length(centros)); %este vector lleva el numero de veces que un centro gana
    for t=1:N
  
        distancias=abs(centros-datos(t)); %%al usar complejos puedo calcular la distancia de un
        %%%patron a los centros de una tacada %%%%%%%%
        [a,ind]=min(distancias); %%%ind indica el centro que gana 
        cont(ind)=cont(ind)+1;
        
    end
    
    % Crear plot clustering
    axes(handles.clustering_axes)
    centros_plot=[centros(1),centros(2);centros(3),centros(4);centros(5),centros(6);centros(7),centros(8);centros(9),centros(10)];
    n=1;
    plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','b')
    hold on
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','g')   
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','r')
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','c')
    n=n+1;  plot(real(centros_plot(n,:)),imag(centros_plot(n,:)),'ko','MarkerFaceColor','m')
    plot(real(datos(:)),imag(datos(:)),'k*')
    xlabel('Frecuencia 1 formante (Hz)');
    ylabel('Frecuencia 2 formante (Hz)');
    legend('/a/','/e/','/i/','/o/','/u/')
    
    if ( (cont(1)+cont(2)==2) || (cont(1)+cont(2)==3) )
        
        plot(real(centros(1)),imag(centros(1)),'ko',real(centros(2)),imag(centros(2)),'ko','MarkerFaceColor',[1,1,1])   %[1,1,1]=color blanco
        title('vocal reconocida /a/','Color','r','FontName','Vineta BT','Fontsize',11)   %r=red=[1,0,0]
        hold off
        
    elseif ( (cont(3)+cont(4)==2) || (cont(3)+cont(4)==3) )
        
        plot(real(centros(3)),imag(centros(3)),'ko',real(centros(4)),imag(centros(4)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /e/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( (cont(5)+cont(6)==2) || (cont(5)+cont(6)==3) )

        plot(real(centros(5)),imag(centros(5)),'ko',real(centros(6)),imag(centros(6)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /i/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( (cont(7)+cont(8)==2) || (cont(7)+cont(8)==3) )
        
        plot(real(centros(7)),imag(centros(7)),'ko',real(centros(8)),imag(centros(8)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /o/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    elseif ( (cont(9)+cont(10)==2) || (cont(9)+cont(10)==3) )
        
        plot(real(centros(9)),imag(centros(9)),'ko',real(centros(10)),imag(centros(10)),'ko','MarkerFaceColor',[1,1,1])
        title('vocal reconocida /u/','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    else
        
        title('repita de nuevo la vocal','Color','r','FontName','Vineta BT','Fontsize',11)
        hold off
        
    end

 end
  
function [handles] = supervision( datos, handles )
    %centros =  [ /a//a/ /e//e/ /i//i/ /o//o/ /u//u/ ]     
    N=length(datos);
    centros=handles.Z_ideal;
    cont=zeros(1,length(centros)); %este vector lleva el numero de veces que un centro gana
    for t=1:N
  
        distancias=abs(centros-datos(t)); %%al usar complejos puedo calcular la distancia de un
        %%%patron a los centros de una tacada %%%%%%%%
        [a,ind]=min(distancias); %%%ind indica el centro que gana 
        cont(ind)=cont(ind)+1;
   
        if (ind == 1 || ind==2)
            handles.clase_a=[handles.clase_a datos(t)];
        elseif (ind == 3 || ind==4)
            handles.clase_e=[handles.clase_e datos(t)];
        elseif (ind == 5 || ind==6)
            handles.clase_i=[handles.clase_i datos(t)];
        elseif (ind == 7 || ind==8)
            handles.clase_o=[handles.clase_o datos(t)];
        else (ind == 9 || ind==10)
            handles.clase_u=[handles.clase_u datos(t)];
        end
            
    end
    
    
function centros = algoritmo_FCM ( XX, handles )

    XXre=real(XX);
    XXim=imag(XX);
    XX=[XXre;XXim];
    XX=XX';         %datos tienen que estar asi dato1 (fila1) ->    columna1 = coordenada x
                    %                                               columna2 = coordenada y
                    %                           dato2 (fila2) ->    columna1 = coordenada x
                    %                                               columna2 = coordenada y
                
                    %cada dato nuevo en una fila.
                
                
    %figure;plot(XX(:,1),XX(:,2),'r.')
    %title('datos');

    %k=input('Dame el numero de centroides ');       %como queremos crear 5 agrupamientos num centroides tiene que ser mayor 
    k=10;                                             %10 por ej

    %opcions(1)=input('Dame el exponente de division de la matriz U ');
    opcions(1)=handles.FCMborro; %variamos el exponente de division para conocer cual es el que mejor resultado nos da
    opcions(2)=500;
    opcions(3)=handles.FCMumbro;
    opcions(4)=0;%1

    [centros,U,obj]=fcm(XX,k,opcions);        % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES es una libreria propia de MATLAB
                                % Se pasan los datos a agrupar(XX) y el numero
                                % de centroides(k)

    
function centros = algoritmo_HCM ( XX , figuras, handles )  
umbral=handles.HCM;
% LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES, pero primero hay que
% inicializar los centroides que nos van a permitir agrupar los patrones (cargamos centroides )

%k=input('Dame el numero de centroides ');       %como queremos crear 5 agrupamientos num centroides tiene que ser mayor 
k=10;                                             %10 por ej
N=length(XX);
%u=randperm(N);
%centros=XX(u(1:k));  %de esta forma los centros los tomo de forma aleatoria pero de datos que se encuentran en el vector XX
load('centroides_ini')      %carga los centros de inicializacion
if figuras==1
    
    figure;plot(real(XX),imag(XX),'r*',real(centros),imag(centros),'bo');title('Inicio, recalcular centros mediante HCM')
    legend('Datos a agrupar','Centros iniciales')
    pause(3);
end
[centros]=calcentro(k,centros,XX,umbral);      % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES
if figuras==1

    figure;plot(real(XX),imag(XX),'r*',real(centros),imag(centros),'bo');title('Despues de todas las iteraciones')
    legend('Datos','Centros resultantes')
    pause(3);
end
   
function centros = algoritmo_LVQ (  handles )    
cte=handles.LVQ;
figuras=handles.procesoLVQ;
if handles.supervision==0
    %**** 1 solucion experto propio sistema basado en LVQ y FCM (archivo IDEAL.M)
    XXaa=handles.clase_a;   
    XXee=handles.clase_e;
    XXii=handles.clase_i;
    XXoo=handles.clase_o;
    XXuu=handles.clase_u;
else
    %**** 2 solucion supervisado propio usuario
    XXaa=handles.clase_usu_a;   
    XXee=handles.clase_usu_e;
    XXii=handles.clase_usu_i;
    XXoo=handles.clase_usu_o;
    XXuu=handles.clase_usu_u;   
end





XX=[XXaa XXee XXii XXoo XXuu];
% LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES, pero primero hay que
% inicializar los centroides que nos van a permitir agrupar los patrones (cargamos centroides )

%k=input('Dame el numero de centroides ');       %como queremos crear 5 agrupamientos num centroides tiene que ser mayor 
k=10;                                             %10 por ej
N=length(XXaa);
%u=randperm(N);
%centros=XX(u(1:k));  %de esta forma los centros los tomo de forma aleatoria pero de datos que se encuentran en el vector XX
load('centroides_ini');       %carga los centros almacenados por clases , hay 2 centros por cada clase 
                        %Centro1 y Centro2 --> clase A
                        %Centro3 y Centro4 --> clase E
                        %Centro5 y Centro6 --> clase I
                        %Centro7 y Centro8 --> clase O
                        %Centro9 y Centro10 --> clase U
                        
if figuras==1
    
    H1=figure;plot(real(XX),imag(XX),'r*',real(centros),imag(centros),'bo');title('Inicio, recalcular centros mediante LVQ')
    legend('Datos a agrupar','Centros iniciales')
    pause(3);
end
%primero el vector de /a/ = clase 1
clase=1;
[centros]=calcentroLVQ(k,centros,XXaa,clase,cte);      % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES
%[centros]=calcentroLVQconCTEvariableTiempo(k,centros,XXaa,clase);

%el vector de /e/ = clase 3
clase=3;
[centros]=calcentroLVQ(k,centros,XXee,clase,cte);      % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES
%[centros]=calcentroLVQconCTEvariableTiempo(k,centros,XXee,clase);
%el vector de /i/ = clase 5
clase=5;
[centros]=calcentroLVQ(k,centros,XXii,clase,cte);      % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES
%[centros]=calcentroLVQconCTEvariableTiempo(k,centros,XXii,clase);
%el vector de /o/ = clase 7
clase=7;
[centros]=calcentroLVQ(k,centros,XXoo,clase,cte);      % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES
%[centros]=calcentroLVQconCTEvariableTiempo(k,centros,XXoo,clase);
%el vector de /u/ = clase 9
clase=9;
[centros]=calcentroLVQ(k,centros,XXuu,clase,cte);      % LLAMANOS A LA FUNCION QUE CALCULA LOS CENTROIDES
%[centros]=calcentroLVQconCTEvariableTiempo(k,centros,XXuu,clase);

if figuras==1
    
    H2=figure;plot(real(XX),imag(XX),'r*',real(centros),imag(centros),'bo');title('Despues de todas las iteraciones')
    legend('Datos','Centros resultantes')
    pause(3);
end


% --- Executes just before reconocedor_vocalico_page2 is made visible.
function reconocedor_vocalico_page2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to reconocedor_vocalico_page2 (see VARARGIN)

%crear estructuras
load('default_page2.mat');
handles.FCMumbro_default=FCMumbro_default;          handles.FCMumbro=FCMumbro_default;      %(por defecto)
handles.FCMborro_default=FCMborro_default;          handles.FCMborro=FCMborro_default;      %(por defecto)
handles.HCM_default=HCM_default;                    handles.HCM=HCM_default;                %(por defecto)
handles.LVQ_default=LVQ_default;                    handles.LVQ=LVQ_default;                %(por defecto)
handles.supervision_default=supervision_default;    handles.supervision=supervision_default;%(por defecto)
handles.procesoFCM_default=procesoFCM_default;      handles.procesoFCM=procesoFCM_default;  %(por defecto)
handles.procesoHCM_default=procesoHCM_default;      handles.procesoHCM=procesoHCM_default;  %(por defecto)
handles.procesoLVQ_default=procesoLVQ_default;      handles.procesoLVQ=procesoLVQ_default;  %(por defecto)
handles.clasificacion_default=clasificacion_default;handles.clasificacion=clasificacion_default; 

load('centroides_FCM.mat');
handles.Z_FCM=centros;
load('centroides_LVQ.mat');
handles.Z_LVQ=centros;
load('centroides_HCM.mat');
handles.Z_HCM=centros;
load('centroides_ideal.mat');
handles.Z_ideal=ideal_a;

load('datos_recalcular_default')
handles.formantes_default=datos_default;

handles.select_vocal=0;
handles.recalcular=0;

if 0
load('datos80porcien')
handles.formantes_ant=datos80porcien;
handles.formantes=datos80porcien;
end
handles.formantes_ant=[0 0 0];      %inicializo los formantes anteriores
handles.formantes=[0 0 0];          %inicializo los nuevos formantes
handles.clases=0;
handles.clase_a=[];
handles.clase_e=[];
handles.clase_i=[];
handles.clase_o=[];
handles.clase_u=[];
handles.clase_supervion_veces=zeros(1,5);
handles.clase_usu_a=[];
handles.clase_usu_e=[];
handles.clase_usu_i=[];
handles.clase_usu_o=[];
handles.clase_usu_u=[];

handles.centros_recalc_FCM=0;
handles.centros_recalc_LVQ=0;
handles.centros_recalc_HCM=0;

%inicializo con FCM por ser el primer metodo que aparece en la lista
handles.current_Z=handles.Z_FCM;

% Choose default command line output for reconocedor_vocalico_page2
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes reconocedor_vocalico_page2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = reconocedor_vocalico_page2_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function plot_barramenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_barramenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in plot_barramenu.
function plot_barramenu_Callback(hObject, eventdata, handles)
% hObject    handle to plot_barramenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns plot_barramenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plot_barramenu

val = get(hObject,'Value');
str = get(hObject, 'String');
switch str{val};
case 'FCM' % User selects cebtroides FCM
    handles.current_Z = handles.Z_FCM;
case 'LVQ' % User selects centroides LVQ
    handles.current_Z = handles.Z_LVQ;
case 'HCM' % User selects centroides HCM
    handles.current_Z = handles.Z_HCM;
end
guidata(hObject,handles)    %guardar cambios

% --- Executes on button press in clasificar_pushbutton.
function clasificar_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to clasificar_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if handles.formantes == [0 0 0]
    
    % Crear en plot clustering no se ha adquirido la voz
    axes(handles.clustering_axes)
    plot(handles.formantes);    
    xlabel('Frecuencia 1 formante (Hz)');
    ylabel('Frecuencia 2 formante (Hz)');
    text(1.4,0.5,'La voz no ha sido adquirida','Color','b')
    text(1.25,0.25,'Presione de nuevo -> Adquirir voz','Color','b')
    
else
    
    %muestra en pantalla los centros y el resultado 
    clustering(handles.formantes, handles.current_Z, handles);
    
end
    


% --- Executes on button press in recalcular_pushbutton.
function recalcular_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to recalcular_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


if sum(handles.formantes_ant) == 0
    
    % Crear en plot clustering no se ha adquirido la voz
    axes(handles.clustering_axes)
    plot(handles.formantes);    
    xlabel('Frecuencia 1 formante (Hz)');
    ylabel('Frecuencia 2 formante (Hz)');
    text(1.4,0.5,'La voz no ha sido adquirida','Color','b')
    text(1.25,0.25,'Presione de nuevo -> Adquirir voz','Color','b')
    %text(540,1750,'La voz no ha sido adquirida','Color','b')
    %text(525,1500,'Presione de nuevo -> Adquirir voz','Color','b')
    
else
    handles.recalcular=1;
    num_datos=length(handles.formantes_ant);
  
    if num_datos>40
        %se recalculan los centros de datos adquiridos si estos son mas de 40 
    else 
        %si no se recalculan los centros de datos por defecto + los adquiridos
        handles.formantes_ant=[handles.formantes_ant handles.formantes_default];
        %%%%%%% falta para LVQ
    end
    
    %ahora si se recalculan los centros
    if (handles.current_Z == handles.Z_FCM)
        
        [centros]=algoritmo_FCM(handles.formantes_ant, handles);
        axes(handles.clustering_axes)
        plot(centros(:,1),centros(:,2),'bo')
        title('Centros recalculados FCM','FontName','Vineta BT','Fontsize',9);
        handles.centros_recalc_FCM=centros;
        
    elseif (handles.current_Z == handles.Z_LVQ)
        
        [centros]=algoritmo_LVQ(handles);
        axes(handles.clustering_axes)
        plot(real(centros),imag(centros),'bo')
        title('Centros recalculados LVQ','FontName','Vineta BT','Fontsize',9);
        handles.centros_recalc_LVQ=centros;

        
    else (handles.current_Z == handles.Z_HCM)
        
        [centros]=algoritmo_HCM(handles.formantes_ant,handles.procesoHCM, handles);
        axes(handles.clustering_axes)
        plot(real(centros),imag(centros),'bo')
        title('Centros recalculados HCM','FontName','Vineta BT','Fontsize',9);
        handles.centros_recalc_HCM=centros;
        
    end
    
end

guidata(hObject,handles)    %guardar cambios



% --- Executes on button press in adquirir_voz_pushbutton.
function adquirir_voz_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to adquirir_voz_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


fin=1;
while (fin==1)
    % adquirir seal analogica de la tarjeta de sonido (input)
    handles = adquirir(hObject, eventdata, handles);

    % Display Online plot of the currently selected data(reconocedor_online)
    %axes(handles.wave_axes)
    text(2900,0.01,'VAD -- En proceso ','Color','b')
    [inicio,norm]=preproceso(handles.voz);
    %Fs = obj.SampleRate;
    %blockSize = obj.SamplesPerTrigger;

    if (inicio~=0 && handles.blockSize-inicio>=800)
        [formantes]=extraccion(inicio, norm, handles.Fs);
        handles.formantes=formantes;

        if sum(handles.formantes_ant) == 0
            
            handles.formantes_ant=formantes;
            
        else
            
            handles.formantes_ant=[handles.formantes_ant formantes];
        end
        
        [handles] = supervision( formantes, handles );
        if(handles.supervision==0)  %si el usuario desea supervisar el LVQ
            supervision_usuario% ir a la pagina
           
            load('select_vocal')
            handles.select_vocal=select_vocal;
            
            if select_vocal(1)==1
                if handles.clase_supervion_veces(1)==0
                    handles.clase_usu_a=formantes;
                    handles.clase_supervion_veces(1)=1;
                else
                    handles.clase_usu_a=[handles.clase_usu_a formantes];
                end
            elseif select_vocal(2)==1
                if handles.clase_supervion_veces(2)==0
                    handles.clase_usu_e=formantes;
                    handles.clase_supervion_veces(2)=1;
                else
                    handles.clase_usu_e=[handles.clase_usu_e formantes];
                end
            elseif select_vocal(3)==1
                if handles.clase_supervion_veces(3)==0
                    handles.clase_usu_i=formantes;
                    handles.clase_supervion_veces(3)=1;
                else
                    handles.clase_usu_i=[handles.clase_usu_i formantes];
                end
            elseif select_vocal(4)==1
                if handles.clase_supervion_veces(4)==0
                    handles.clase_usu_o=formantes;
                    handles.clase_supervion_veces(4)=1;
                else
                    handles.clase_usu_o=[handles.clase_usu_o formantes];
                end
            elseif select_vocal(5)==1
                if handles.clase_supervion_veces(5)==0
                    handles.clase_usu_u=formantes;
                    handles.clase_supervion_veces(5)=1;
                else
                    handles.clase_usu_u=[handles.clase_usu_u formantes];
                end
            end
            
        end
        guidata(hObject,handles)    %guardar cambios
        fin=0;
    end
end


% --- Executes on button press in offline_pushbutton.
function offline_pushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to offline_pushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%open('reconocedor_vocalico_page1.fig');
close('reconocedor_vocalico_page2');


% --------------------------------------------------------------------
function menu_salir_Callback(hObject, eventdata, handles)
% hObject    handle to menu_salir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close('reconocedor_vocalico_page1');
close('reconocedor_vocalico_page2');


% --------------------------------------------------------------------
function menu_opciones_Callback(hObject, eventdata, handles)
% hObject    handle to menu_opciones (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_FCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_FCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_var_FCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_var_FCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_no_var_FCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_var_FCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.FCMumbro=handles.FCMumbro_default;
handles.FCMborro=handles.FCMborro_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_si_var_FCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_var_FCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.FCMumbro), num2str(handles.FCMborro), num2str(handles.HCM), num2str(handles.LVQ) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables2(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.FCMumbro = str2num( datos_act{1} );
handles.FCMborro = str2num( datos_act{2} );
handles.HCM = str2num( datos_act{3} );
handles.LVQ = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios


% --------------------------------------------------------------------
function menu_var_HCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_var_HCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_no_var_HCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_var_HCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.HCM=handles.HCM_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_si_var_HCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_var_HCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.FCMumbro), num2str(handles.FCMborro), num2str(handles.HCM), num2str(handles.LVQ) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables2(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.FCMumbro = str2num( datos_act{1} );
handles.FCMborro = str2num( datos_act{2} );
handles.HCM = str2num( datos_act{3} );
handles.LVQ = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_proceso_HCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_proceso_HCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_si_proceso_HCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_proceso_HCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.procesoHCM=1;
guidata(hObject, handles);    %guardar cambios


% --------------------------------------------------------------------
function menu_no_proceso_HCM_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_proceso_HCM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.procesoHCM=0;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_var_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_var_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_no_var_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_var_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.LVQ=handles.LVQ_default;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_si_var_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_var_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
datos_ant={ num2str(handles.FCMumbro), num2str(handles.FCMborro), num2str(handles.HCM), num2str(handles.LVQ) };
            %son caracteres {'0','3','12',5000}

datos_act=intro_datos_modificables2(datos_ant);
[f,c]=size(datos_act);
if (f==0 && c==0)
    datos_act = datos_ant;  %si en el dlg cancelas, se mantienen los datos anteriores
end
handles.FCMumbro = str2num( datos_act{1} );
handles.FCMborro = str2num( datos_act{2} );
handles.HCM = str2num( datos_act{3} );
handles.LVQ = str2num( datos_act{4} );
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_ayuda_Callback(hObject, eventdata, handles)
% hObject    handle to menu_ayuda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_manual_Callback(hObject, eventdata, handles)
% hObject    handle to menu_manual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hBar = waitbar(0.25,'Opening internet browser...');
pause(0.5)
waitbar(1);
pause(0.3)
letras=length(mfilename);
lugar = which(mfilename);
URL = [ lugar(1:end-letras-2) , 'ayuda\','Manual.htm'];
STAT = web(URL,'-browser');
close(hBar);    
switch STAT
case {1,2}
    s = {'Su navegador no se ha activado o no ha' , ...
	     'encontrado el archivo.  Por favor use su' , ...
	     'navegador para abrir el archivo:' , ...
	     ' ', '     Manual.htm', ' ', ...
	     'se encuentra en el directorio ayuda de RVIL-AC.'};
    errordlg(s,'Error al lanzar el navegador.');
end


% --------------------------------------------------------------------
function menu_supervision_Callback(hObject, eventdata, handles)
% hObject    handle to menu_supervision (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_supervision_auto_Callback(hObject, eventdata, handles)
% hObject    handle to menu_supervision_auto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.supervision=1;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_supervision_usu_Callback(hObject, eventdata, handles)
% hObject    handle to menu_supervision_usu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.supervision=0;
guidata(hObject, handles);    %guardar cambios


% --------------------------------------------------------------------
function menu_si_proceso_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_si_proceso_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.procesoLVQ=1;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_no_proceso_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_no_proceso_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.procesoLVQ=0;
guidata(hObject, handles);    %guardar cambios


% --------------------------------------------------------------------
function menu_proceso_LVQ_Callback(hObject, eventdata, handles)
% hObject    handle to menu_proceso_LVQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_clasificacion_Callback(hObject, eventdata, handles)
% hObject    handle to menu_clasificacion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_clasificacion_proyecto_Callback(hObject, eventdata, handles)
% hObject    handle to menu_clasificacion_proyecto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.clasificacion=0;
guidata(hObject, handles);    %guardar cambios


% --------------------------------------------------------------------
function menu_clasificacion_usuario_Callback(hObject, eventdata, handles)
% hObject    handle to menu_clasificacion_usuario (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.clasificacion=1;
guidata(hObject, handles);    %guardar cambios

% --------------------------------------------------------------------
function menu_var_defecto_Callback(hObject, eventdata, handles)
% hObject    handle to menu_var_defecto (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.FCMumbro=handles.FCMumbro_default;         
handles.FCMborro=handles.FCMborro_default;          
handles.HCM=handles.HCM_default;                    
handles.LVQ=handles.LVQ_default;  
guidata(hObject, handles);    %guardar cambios

